// Welcome to the SexScript editor. This is the standard template
// text (from template.groovy). Delete those comments as you make
// your own script from it. 
//
// General info (must be present one time at the start) : 
// - Ss software script language version, "API" (now : API = 4)
// - A title of your choice (less than 50 characters)
// - A summary (less than 250 characters) ; avoid writing "my first script"
// - Author (yourself, or "Anonymous")
// - Current status : "started", "incomplete", "test", "complete" ...
// - Background color, hexadecimal RedGreenBlue (here, for example : white) 
// - Language (2 letters, see ISO 639-1), samples : "en", "de", "ar", "zh"... 
// - Tags (any number of tags, see samples on website)
setInfos(4, "Dice Game - Single Opponent", "Spanked if you lose, get to wank if you win", "marspank", "started", 0xFFFFFF, "en", ["spanking", "", ""]);

def spankMultiplier = 2
def strokeMultiplier = 5

def gameEndValue = 100

def mistressTotal = 0
def playerTotal = 0

def roundTotal = 0

def rounds = 0
def rollCount = 0

def display = ""

def mistressRollDecision = 6
def mistressTotalDecision = 15

def getLightImplement = {
	def implementList = new String[0]
	if(loadBoolean("toys.wooden_spoon")) implementList+="wooden spoon"
	if(loadBoolean("toys.slipper")) implementList+="slipper"
	if(loadBoolean("toys.spatula")) implementList+="spatula"
	if(loadBoolean("toys.flyswatter")) implementList+="fly swatter"
	if(loadBoolean("toys.ruler")) implementList+="ruler"
	if(loadBoolean("toys.sandal")) implementList+="sandal"
	return implementList[getRandom(implementList.size())]
}
def getMediumImplement = {
	def implementList = ["hair brush"]
	if(loadBoolean("toys.bathbrush")) implementList+="bath brush"
	if(loadBoolean("toys.hairbrush")) implementList+="hair brush"
	if(loadBoolean("toys.paddle")) implementList+="paddle"
	if(loadBoolean("toys.wooden_spoon")) implementList+="wooden spoon"

	return implementList[getRandom(implementList.size())]
}
def getHeavyImplement = {
	def implementList = ["bath brush"]
	if(loadBoolean("toys.bathbrush")) implementList+="bath brush"
	if(loadBoolean("toys.crop")) implementList+="crop"
	if(loadBoolean("toys.paddle")) implementList+="paddle"
	if(loadBoolean("toys.paddle_holes")) implementList+="paddle with holes"

	return implementList[getRandom(implementList.size())]
}
def x = 0
def spank = {
		message, spanks, time ->
		show(""+message+"\n\n. . ")
		wait(2)
		(1..spanks).each {
			x++
			show(message+"\n\n."+x+".")
			playBackgroundSound("swat.wav")
			wait(time)
		}
	}
def stroke = {
	message, strokes, time ->
	show(""+message+"\n\n. . ")
	wait(time)
	(1..strokes).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("tom.wav")
		wait(time)
	}
}
def displayTotals = {
	display = "Mistress Total: "+mistressTotal+"\nPlayer Total: "+playerTotal+"\n"+"Current Round Total: "+roundTotal+"\nRound Rolls: "+rollCount+"\n\n\n\n\n\n\n"
}
def mistressDecision = { decision ->
	if(mistressTotal + roundTotal >= 100) return true
	switch(decision){
		case 0:
			if(rollCount >= mistressRollDecision) return true
			else if(roundTotal > 25) return true
			else return false
		case 1:
			if(roundTotal >= mistressTotalDecision) return true
			else return false
		case 2:
			if(rollCount > 1 && roundTotal >= (7-rollCount)*(rollCount)) return true
			else return false
		case 3:
			if(getRandom(6) == 0) return true
			else return false
	}
}

def mistressRound = {
	def keepPlaying = true
	roundTotal = 0
	
	def decisionRule = getRandom(4)

	rollCount = 0

	while(keepPlaying)
	{
		def diceRoll = getRandom(6)+1
		rollCount++
		if(diceRoll == 1)
		{
			def oneMessages = ["Looks like you got lucky, I rolled a 1","Oh no! I rolled a 1"
				,"I can't believe it, I got a 1","I got a 1 this time, but next round is mine"]
			displayTotals()
			show(display+oneMessages[getRandom(4)]+"\n\n\n\n\n\n\n.")
			wait(10)
			roundTotal = 0
			keepPlaying = false
		}
		else
		{
			def rollMessages = ["Nice, I rolled a ","Looks like I rolled a ","I rolled a "]
			displayTotals()
			show(display+rollMessages[getRandom(3)]+diceRoll+"\n\n\n\n\n\n\n\n.")
			roundTotal += diceRoll;
			wait(5)
			def totalMessages = ["My new round total is ","That brings my total to ","Now I have "]
			
			if(mistressDecision(decisionRule))
			{
				def stopMessages = ["That is good enough for this round, time to cash in",
					"That is enough for this round","I will take those points",
					"I am not going to push my luck any further"]
				displayTotals()
				show(display+totalMessages[getRandom(3)]+roundTotal+" points\n\n"+stopMessages[getRandom(4)]
					+"\n\n\n\n\n\n.")
				wait(5)
				keepPlaying = false
			}
			else
			{
				def playMessages = ["Hmm... not quite enough, I am going to keep rolling",
					"I think I will press my luck","No time to stop, have to keep rolling",
					"I am going to roll again, I need to build up more points to spank you with"]
				displayTotals()
				show(display+totalMessages[getRandom(3)]+roundTotal+" points\n\n"+playMessages[getRandom(4)]
					+"\n\n\n\n\n\n.")
				wait(5)
				keepPlaying = true
			}
		}
	}
	def passMessages
	if(roundTotal == 0)
	{
		if(mistressTotal >= playerTotal)
		{
			passMessages = ["Here is your chance to catch up, don't blow it by rolling too much",
				"Guess I gave you a good chance to get out of the hole"
				,"Too bad I couldn't increase my lead this round","Well, I guess it is your turn now"]
		}
		else
		{
			passMessages = ["Shoot, now you can build up the lead even more",
				"You know you wanted me to catch up so I could spank you, don't lie",
				"This is your chance to get some stroking in, don't blow it",
				"Guess I will have to make up the gap next round"]
			
		}
		displayTotals()
		show(passMessages[getRandom(4)])
		wait(8)
	}
	else
	{
		passMessages = ["Looks like you have some work to do, I got ",
			"Not a bad round for me, I got ","I am happy taking "]
		mistressTotal += roundTotal
		displayTotals()
		show(display+passMessages[getRandom(3)]+roundTotal+" points.\n\n\n\n\n\n.")
		wait(10)
	}
}
def playerRound = {
	roundTotal = 0
	rollCount = 0
	def keepPlaying = true
	def diceRoll

	def messages

	while(keepPlaying)
	{
		diceRoll = getRandom(6)+1
		rollCount++
		if(diceRoll == 1)
		{
			if(rollCount == 1)
			{
				messages = ["Poor baby, you got a 1 on your first roll"
					,"Looks like you are unlucky, a 1 on the first roll"
					,"A 1 on the first roll? Someone wants to get their butt spanked"]
			}
			else
			{
				messages = ["You rolled a 1 sweetie, guess you got too greedy"
					,"I am so glad you rolled a 1, your total was starting to worry me"
					,"Looks like this round is over for you,\n you just rolled a 1"]
			}
			roundTotal = 0
			displayTotals()
			show(display + messages[getRandom(3)]+"\n\n\n\n\n\n\n.")
			if(mistressTotal < gameEndValue)showButton("Your turn then Mistress")
			else showButton("I couldn't catch up mistress")
			keepPlaying = false
			
		}
		else
		{
			roundTotal += diceRoll
			displayTotals()
			if(getBoolean(display+"You rolled a "+diceRoll+", which brings your round total to "+roundTotal
					+".\nWhat do you want to do?\n\n\n\n\n\n\n.","Roll","Stay"))
			{
				//show("So you are going to roll again? Good Luck")
				//wait(5)
				keepPlaying = true
			}
			else
			{
				//show("Not going to keep pressing? Ok")
				//wait(5)
				keepPlaying = false
			}
		}
	}
	if(roundTotal != 0)
	{
		playerTotal += roundTotal
		displayTotals()
		show(display+"You got "+roundTotal+" points that round. That brings your grand total to "+playerTotal
			+"\n\n\n\n\n\n\n.")
		wait(10)
	}
}
while(mistressTotal < gameEndValue && playerTotal < gameEndValue)
{
	rounds++
	if(rounds == 1) show("I'll go first, but don't worry we will both get the same number of turns")
	else show("My turn now")
	wait(5)
	mistressRound()
	if(mistressTotal > gameEndValue)
	{
		show("This is going to be your last chance to score points."
		+"\nBetter make it count.")
		wait(5)
	}
	playerRound()
}
if(mistressTotal > playerTotal)
{
	show("Looks like I win you naughty boy. Now it is time for your spanking."
		+"\n\nGet those pants and underpants around your ankles")
	showButton("Yes Mistress")

	def totalSpanks = (mistressTotal - playerTotal)*spankMultiplier
	def spankRounds = (int) totalSpanks / 20
	def leftoverSpanks = totalSpanks % 20

	def mediumImplement = getMediumImplement()
	def heavyImplement = getHeavyImplement()

	def thirdLeft = (int) spankRounds*(2.0/3)+1

	show("We will start with the "+mediumImplement)
	showButton("Ready Miss")
	def i=1
	while(i <= spankRounds)
	{
		if(i == thirdLeft && i > 2)
		{
			show("Time to switch over to the "+heavyImplement)
			showButton("Have it Miss")
		}
		if(i == spankRounds) spank("Final Round, Really HARD",20+leftoverSpanks,1)
		else spank("Alternate cheeks HARD",20,1)
		i++
	}
	if(spankRounds == 0)
	{
		show("Lucky you, not even a full 20 swats, but you still have some coming")
		wait(5)
		spank("Alternate cheeks HARD",leftoverSpanks,1)
	}
}
else if(playerTotal > mistressTotal)
{
	show("I can't believe you beat me. You have earned yourself some strokes.")
	wait(5)
	def totalStrokes = (playerTotal - mistressTotal)*strokeMultiplier
	def strokeRounds = (int) totalStrokes / 50
	def remainingStrokes = totalStrokes % 50

	def firstThird = (int) strokeRounds*(1.0/3)+1
	def finalThird = (int) strokeRounds*(2.0/3)+1

	def strokeTime = 1

	def message = "slow strokes"

	def i=1
	while(i <= strokeRounds)
	{
		if(i == firstThird && i >= 2)
		{
			strokeTime = 0.75
			message = "medium strokes"
		}
		else if(i==finalThird && i>=4)
		{
			strokeTime = 0.5
			message = "faster strokes"
		}
		else if(i == strokeRounds && i > 5)
		{
			strokeTime = 0.25
			message = "fast strokes"
		}
		if(i == strokeRounds) stroke(message,50+remainingStrokes,strokeTime)
		else stroke(message,50,strokeTime)
		i++
	}
	if(strokeRounds == 0)
	{
		strokeTime = 2
		show("Poor baby, you couldn't even earn 50 strokes.\n\n"+
			"Don't worry, I will make this stroking session last for you.")
		wait(5)
		stroke("Savor these strokes",remainingStrokes,strokeTime)
	}
}

show("Thanks for playing with me")
showButton("End")



// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/
// (Author may change thoses lines)
